import { ArrayToArrayUrlParams } from "./helpers";
import { TCategory, TTag, TVenue, TVenueFilters } from "./types";

export class API {
    constructor(private baseAPIUrl: string) {}

    getVenues = async (venueFilters: TVenueFilters | null): Promise<TVenue[]> => {
        const categoriesParams = ArrayToArrayUrlParams("categories", venueFilters?.categories.map((c) => c.name) ?? []);
        const response = await fetch(`${this.baseAPIUrl}/venue${categoriesParams}`);
        console.log(`calling ${this.baseAPIUrl}/venue${categoriesParams}`);
        return await response.json();
    }

    getCategories = async (): Promise<TCategory[]> => {
        const response = await fetch(`${this.baseAPIUrl}/category`);
        return await response.json();
    }

    getTags = async (): Promise<TTag[]> => {
        const response = await fetch(`${this.baseAPIUrl}/tag`);
        return await response.json();
    }
}